#ifndef _ARP_H
#define _ARP_H

#include "../eth_base/eth.h"
#include "../ipv4_base/ipv4.h"

#define ARP_DATA_LENGTH 28
#define ARP_MSG_HW_TYPE 0x0001
#define ARP_MSG_PT_TYPE 0x0800
#define ARP_ETH_TYPE 0x0806 /*'type': Valor . Define ARP como valor del campo 'Tipo' de la trama Ethernet a enviar */
#define ARP_OPCODE_REQUEST 0x0001
#define ARP_OPCODE_REPLY 0x0002

typedef struct arp_message arp_message_t;

/* int arp_resolve ( eth_iface_t *iface, ipv4_addr_t ip_addr, mac_addr_t mac_addr )

  DESCRIPCIÓN:
    Esta función envía una petición ARP por el interfaz Ethernet especificado

  PARÁMETROS:
     'iface': Manejador de la interfaz Ethernet por la que se quiere enviar
              el paquete.
              La interfaz debe haber sido inicializada con 'eth_open()'
              previamente.
       'ip_addr': Dirección IP del equipo destino.
       'mac_addr': Dirección MAC que tiene que ser rellenada con la información correspondiente.

  VALOR DEVUELTO:
 		 0 : [CORRECTO] La petición ha sido enviada y recibida la respuesta correctamente.
 		-1 : [ERROR] La respuesta no ha llegado después de 2 segundos.
*/

int arp_resolve (eth_iface_t * iface, ipv4_addr_t my_ip_addr, ipv4_addr_t ip_addr, mac_addr_t mac_addr);

#endif /* _ARP_H */
