#include "../../files/arp/arp.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <libgen.h>

#define DEFAULT_PAYLOAD_LENGTH 1500

/* int main ( int argc, char * argv[] );
 *
 * DESCRIPCIÓN:
 *   Función principal del programa.
 *
 * PARÁMETROS:
 *   'argc': Número de parámetros pasados al programa por la línea de
 *           comandos, incluyendo el propio nombre del programa.
 *   'argv': Array con los parámetros pasado al programa por línea de
 *           comandos.
 *           El primer parámetro (argv[0]) es el nombre del programa.
 *
 * VALOR DEVUELTO:
 *   Código de salida del programa.
 */
int main ( int argc, char * argv[] )
{

  char * myself = basename(argv[0]);
  if (argc != 3) {
    printf("Uso: %s <arp_client> <iface> <ip> \n", myself);
    printf("       <iface>: Nombre de la interfaz Ethernet\n");
    printf("         <ip>: Dirección IP \n");
    exit(-1);
  }

  /* Procesar los argumentos de la línea de comandos */

  char * iface_name = argv[1];
  char * ip_addr_str = argv[2];

  ipv4_addr_t ip_addr_dest;

  int err = ipv4_str_addr (ip_addr_str, ip_addr_dest);
  if (err == -1) {
    printf("No es una dirección IP correcta.\n");
    exit(-1);
  }

  /* Abrir la interfaz Ethernet */
  printf("Abriendo interfaz Ethernet %s.\n", iface_name);
  eth_iface_t *eth_iface = eth_open(iface_name);

  if (eth_iface == NULL) {
    fprintf(stderr, "%s: ERROR al abrir la interfaz (\"%s\")\n", myself, iface_name);
    exit(-1);
  }

  mac_addr_t mac_addr;
  char mac_str[MAC_STR_LENGTH];

  int arp = arp_resolve (eth_iface, ip_addr_dest, mac_addr);

  if(arp == -1){
    printf("Error al enviar o recibir ARP. Representa un problema con la capa Ethernet o la Librawnet.\n");
    return -1;
  } else if (arp == 1) {
    printf("Timeout\n");
  } else if (arp == 0) {
    printf("ARP correcto.\n");
    mac_addr_str (mac_addr, mac_str);
    printf("%s -> %s\n", ip_addr_str, mac_str);
  }

  /* Cerrar interfaz Ethernet */
  printf("Cerrando interfaz Ethernet %s.\n", iface_name);
  eth_close(eth_iface);



}
